;=======================================
;	wywietlacz segmentowy
;	screen.asm
;
; 1 padziernik 2010
;
; Dawid Urbaski
; url: www.dawidurbanski.pl
; email: dawid.urb@wp.pl
;
;========================================

/*====================================
	 __a__
	|	  |
	f     b
	|     |
	 __a__
	|	  |
	e     c
	|     |
	 __d__    P-D
  ====================================*/

.set EKRAN_a_PORT	= 	PORTB
.set EKRAN_a_PIN	= 	6

.set EKRAN_b_PORT	= 	PORTB
.set EKRAN_b_PIN	= 	0

.set EKRAN_c_PORT	= 	PORTB
.set EKRAN_c_PIN	= 	1

.set EKRAN_d_PORT	= 	PORTB
.set EKRAN_d_PIN	= 	2

.set EKRAN_e_PORT	= 	PORTB
.set EKRAN_e_PIN	= 	3

.set EKRAN_f_PORT	= 	PORTB
.set EKRAN_f_PIN	= 	4

.set EKRAN_g_PORT	= 	PORTB
.set EKRAN_g_PIN	= 	5

.set EKRAN_PD_PORT	= 	PORTB
.set EKRAN_PD_PIN	= 	7

;-ustawienia dla obsugi 4 ekranw-
.set EKRAN_1_PORT	= 	PORTD
.set EKRAN_1_PIN	= 	5

.set EKRAN_2_PORT	= 	PORTD
.set EKRAN_2_PIN	= 	4

.set EKRAN_3_PORT	= 	PORTD
.set EKRAN_3_PIN	= 	3

.set EKRAN_4_PORT	= 	PORTD
.set EKRAN_4_PIN	= 	6
;-------------------------------



EKRAN_TEST:

	rcall EKRAN_INIT
	rcall EKRAN_1_ON
	rcall EKRAN_2_ON
	rcall EKRAN_3_ON
	rcall EKRAN_4_ON

	cbi EKRAN_a_PORT,EKRAN_a_PIN
	rcall w1
	rcall w1
	sbi EKRAN_a_PORT,EKRAN_a_PIN

	cbi EKRAN_b_PORT,EKRAN_b_PIN
	rcall w1
	rcall w1
	sbi EKRAN_b_PORT,EKRAN_b_PIN

	cbi EKRAN_c_PORT,EKRAN_c_PIN
	rcall w1
	rcall w1
	sbi EKRAN_c_PORT,EKRAN_c_PIN

	cbi EKRAN_d_PORT,EKRAN_d_PIN
	rcall w1
	rcall w1
	sbi EKRAN_d_PORT,EKRAN_d_PIN

	cbi EKRAN_e_PORT,EKRAN_e_PIN
	rcall w1
	rcall w1
	sbi EKRAN_e_PORT,EKRAN_e_PIN

	cbi EKRAN_f_PORT,EKRAN_f_PIN
	rcall w1
	rcall w1
	sbi EKRAN_f_PORT,EKRAN_f_PIN

	cbi EKRAN_g_PORT,EKRAN_g_PIN
	rcall w1
	rcall w1
	sbi EKRAN_g_PORT,EKRAN_g_PIN

	cbi EKRAN_PD_PORT,EKRAN_PD_PIN
	rcall w1
	rcall w1
	sbi EKRAN_PD_PORT,EKRAN_PD_PIN

rcall EKRAN_INIT

ret
;---------------------------
;wyswietla liczbe 0,1,2,3,4,5,6,7,8,9
EKRAN_DIS:

	CPI r16,0
	BREQ __EKRAN_DIS_0

	CPI r16,1
	BREQ __EKRAN_DIS_1

	CPI r16,2
	BREQ __EKRAN_DIS_2

	CPI r16,3
	BREQ __EKRAN_DIS_3

	CPI r16,4
	BREQ __EKRAN_DIS_4

	CPI r16,5
	BREQ __EKRAN_DIS_5

	CPI r16,6
	BREQ __EKRAN_DIS_6

	CPI r16,7
	BREQ __EKRAN_DIS_7

	CPI r16,8
	BREQ __EKRAN_DIS_8

	CPI r16,9
	BREQ __EKRAN_DIS_9

ret

__EKRAN_DIS_0:
	rcall EKRAN_DIS_0;
	ret;
__EKRAN_DIS_1:
	rcall EKRAN_DIS_1;
	ret;
__EKRAN_DIS_2:
	rcall EKRAN_DIS_2;
	ret;
__EKRAN_DIS_3:
	rcall EKRAN_DIS_3;
	ret;
__EKRAN_DIS_4:
	rcall EKRAN_DIS_4;
	ret;
__EKRAN_DIS_5:	
	rcall EKRAN_DIS_5;
	ret;
__EKRAN_DIS_6:
	rcall EKRAN_DIS_6;
	ret;
__EKRAN_DIS_7:
	rcall EKRAN_DIS_7;
	ret;
__EKRAN_DIS_8:
	rcall EKRAN_DIS_8;
	ret;
__EKRAN_DIS_9:
	rcall EKRAN_DIS_9;
	ret;


;---------------------------


;---------------------------
;inicjuje ekran
EKRAN_INIT:

	;- - - - - - - - - - - - - - - - - - - - - 
	;inicjacja portow sterujacych wl ekranow
	sbi EKRAN_1_PORT,	EKRAN_1_PIN
	cbi EKRAN_1_PORT-1,	EKRAN_1_PIN	

	sbi EKRAN_2_PORT,	EKRAN_2_PIN
	cbi EKRAN_2_PORT-1,	EKRAN_2_PIN	

	sbi EKRAN_3_PORT,	EKRAN_3_PIN
	cbi EKRAN_3_PORT-1,	EKRAN_3_PIN	

	sbi EKRAN_4_PORT,	EKRAN_4_PIN
	cbi EKRAN_4_PORT-1,	EKRAN_4_PIN	
	;- - - - - - - - - - - - - - - - - - - - - 

	;- - - - - - - - - - - - - - - - - - - - - 
	;lampka nie wieci w gdy:
	;
	;	jako wyjscie w stanie wysokim

	; (PORTD-1) = DDRD
	sbi EKRAN_a_PORT,	EKRAN_a_PIN
	sbi EKRAN_a_PORT-1,	EKRAN_a_PIN	

	sbi EKRAN_b_PORT,	EKRAN_b_PIN
	sbi EKRAN_b_PORT-1,	EKRAN_b_PIN

	sbi EKRAN_c_PORT,	EKRAN_c_PIN
	sbi EKRAN_c_PORT-1,	EKRAN_c_PIN

	sbi EKRAN_d_PORT,	EKRAN_d_PIN
	sbi EKRAN_d_PORT-1,	EKRAN_d_PIN

	sbi EKRAN_e_PORT,	EKRAN_e_PIN
	sbi EKRAN_e_PORT-1,	EKRAN_e_PIN

	sbi EKRAN_f_PORT,	EKRAN_f_PIN
	sbi EKRAN_f_PORT-1,	EKRAN_f_PIN

	sbi EKRAN_g_PORT,	EKRAN_g_PIN
	sbi EKRAN_g_PORT-1,	EKRAN_g_PIN

	sbi EKRAN_PD_PORT,	EKRAN_PD_PIN
	sbi EKRAN_PD_PORT-1,EKRAN_PD_PIN
	;- - - - - - - - - - - - - - - - - - - - - 
ret


;-----------------------------------
;procedury w. ekranw
EKRAN_1_ON:
	sbi EKRAN_1_PORT-1,	EKRAN_1_PIN	
ret;

EKRAN_1_OFF:
	cbi EKRAN_1_PORT-1,	EKRAN_1_PIN	
ret;


EKRAN_2_ON:
	sbi EKRAN_2_PORT-1,	EKRAN_2_PIN	
ret;

EKRAN_2_OFF:
	cbi EKRAN_2_PORT-1,	EKRAN_2_PIN	
ret;

EKRAN_3_ON:
	sbi EKRAN_3_PORT-1,	EKRAN_3_PIN	
ret;

EKRAN_3_OFF:
	cbi EKRAN_3_PORT-1,	EKRAN_3_PIN	
ret;

EKRAN_4_ON:
	sbi EKRAN_4_PORT-1,	EKRAN_4_PIN	
ret;

EKRAN_4_OFF:
	cbi EKRAN_4_PORT-1,	EKRAN_4_PIN	
ret;
;-----------------------------------

;mrugniecie
.macro BLINK

	
	cbi	@0,@1
	rcall w1
	sbi	@0,@1


.ENDMACRO


;wywietl symbol '0'
EKRAN_DIS_0:
	cbi EKRAN_a_PORT,EKRAN_a_PIN
	cbi EKRAN_b_PORT,EKRAN_b_PIN
	cbi EKRAN_c_PORT,EKRAN_c_PIN
	cbi EKRAN_d_PORT,EKRAN_d_PIN
	cbi EKRAN_e_PORT,EKRAN_e_PIN
	cbi EKRAN_f_PORT,EKRAN_f_PIN
ret


;wywietl symbol 'E'
EKRAN_DIS_E:
	cbi EKRAN_a_PORT,EKRAN_a_PIN
	cbi EKRAN_f_PORT,EKRAN_f_PIN
	cbi EKRAN_g_PORT,EKRAN_g_PIN
	cbi EKRAN_e_PORT,EKRAN_e_PIN	
	cbi EKRAN_d_PORT,EKRAN_d_PIN	
ret

;wywietl symbol '1'
EKRAN_DIS_1:
	cbi EKRAN_b_PORT,EKRAN_b_PIN
	cbi EKRAN_c_PORT,EKRAN_c_PIN
ret

;wywietl symbol '2'
EKRAN_DIS_2:
	cbi EKRAN_a_PORT,EKRAN_a_PIN
	cbi EKRAN_b_PORT,EKRAN_b_PIN
	cbi EKRAN_g_PORT,EKRAN_g_PIN
	cbi EKRAN_e_PORT,EKRAN_e_PIN
	cbi EKRAN_d_PORT,EKRAN_d_PIN
ret

;wywietl symbol '3'
EKRAN_DIS_3:
	cbi EKRAN_a_PORT,EKRAN_a_PIN
	cbi EKRAN_b_PORT,EKRAN_b_PIN
	cbi EKRAN_g_PORT,EKRAN_g_PIN
	cbi EKRAN_c_PORT,EKRAN_c_PIN
	cbi EKRAN_d_PORT,EKRAN_d_PIN
ret

;wywietl symbol '4'
EKRAN_DIS_4:
	cbi EKRAN_f_PORT,EKRAN_f_PIN
	cbi EKRAN_g_PORT,EKRAN_g_PIN
	cbi EKRAN_c_PORT,EKRAN_c_PIN
	cbi EKRAN_b_PORT,EKRAN_b_PIN
ret


;wywietl symbol '5'
EKRAN_DIS_5:
	cbi EKRAN_a_PORT,EKRAN_a_PIN
	cbi EKRAN_f_PORT,EKRAN_f_PIN
	cbi EKRAN_g_PORT,EKRAN_g_PIN
	cbi EKRAN_c_PORT,EKRAN_c_PIN
	cbi EKRAN_d_PORT,EKRAN_d_PIN
ret

;wywietl symbol '6'
EKRAN_DIS_6:
	cbi EKRAN_a_PORT,EKRAN_a_PIN
	cbi EKRAN_f_PORT,EKRAN_f_PIN
	cbi EKRAN_g_PORT,EKRAN_g_PIN
	cbi EKRAN_c_PORT,EKRAN_c_PIN
	cbi EKRAN_d_PORT,EKRAN_d_PIN
	cbi EKRAN_e_PORT,EKRAN_e_PIN
ret

;wywietl symbol '7'
EKRAN_DIS_7:
	cbi EKRAN_a_PORT,EKRAN_a_PIN
	cbi EKRAN_b_PORT,EKRAN_b_PIN
	cbi EKRAN_c_PORT,EKRAN_c_PIN
ret


;wywietl symbol '8'
EKRAN_DIS_8:
	cbi EKRAN_a_PORT,EKRAN_a_PIN
	cbi EKRAN_b_PORT,EKRAN_b_PIN
	cbi EKRAN_c_PORT,EKRAN_c_PIN
	cbi EKRAN_d_PORT,EKRAN_d_PIN
	cbi EKRAN_e_PORT,EKRAN_e_PIN
	cbi EKRAN_f_PORT,EKRAN_f_PIN
	cbi EKRAN_g_PORT,EKRAN_g_PIN
ret

;wywietl symbol '9'
EKRAN_DIS_9:
	cbi EKRAN_a_PORT,EKRAN_a_PIN
	cbi EKRAN_b_PORT,EKRAN_b_PIN
	cbi EKRAN_f_PORT,EKRAN_f_PIN
	cbi EKRAN_g_PORT,EKRAN_g_PIN
	cbi EKRAN_c_PORT,EKRAN_c_PIN
	cbi EKRAN_d_PORT,EKRAN_d_PIN
ret

;wywietl symbol '.'
EKRAN_DIS_PD:
	cbi EKRAN_PD_PORT,EKRAN_PD_PIN
ret

;---------------------------------
;odczekaj czas [okoo 1s dla 1Mhz]
;---------------------------------
w1:
push r16
push r17
	;ldi r21,5
	;dalay_loopk:
	;---------------------
		LDI r16,200
		delay_loopMYu:
			;------------------------
			LDI r17, 200

			delay_loopMY:

			nop
			nop
			nop
			nop
			nop

			nop
			nop
			nop
			nop
			nop

			DEC r17; 1 takt 
			BRNE delay_loopMY; 2 takty 
			;------------------------
		DEC r16; 1 takt 
		BRNE delay_loopMYu; 2 takty 
	;---------------------
	;DEC r21
	;BRNE dalay_loopk
	pop r17
	pop r16

ret
;---------------------------------
